# HG changeset patch
# User Colin Macdonald <cbm@m.fsf.org>
# Date 1431469222 -3600
#      Tue May 12 23:20:22 2015 +0100
# Node ID 52f3f59f0fbe65c2e84f18687499de0cdccbd032
# Parent  a29374f709a5f334d39c57fc3d4fe8585b45b3d5
doctests: clean up some documentation for doctests pass

diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/cross.m
--- a/scripts/linear-algebra/cross.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/cross.m	Tue May 12 23:20:22 2015 +0100
@@ -25,7 +25,7 @@
 ## @example
 ## @group
 ## cross ([1,1,0], [0,1,1])
-##      @result{} [ 1; -1; 1 ]
+##      @result{}  1  -1   1
 ## @end group
 ## @end example
 ##
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/expm.m
--- a/scripts/linear-algebra/expm.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/expm.m	Tue May 12 23:20:22 2015 +0100
@@ -27,9 +27,9 @@
 ## @end tex
 ## @ifnottex
 ##
-## @example
-## expm (A) = I + A + A^2/2! + A^3/3! + @dots{}
-## @end example
+## @verbatim
+##      expm (A) = I + A + A^2/2! + A^3/3! + @dots{}
+## @end verbatim
 ##
 ## @end ifnottex
 ## The Taylor series is @emph{not} the way to compute the matrix
@@ -43,12 +43,10 @@
 ## @end tex
 ## @ifnottex
 ##
-## @example
-## @group
-##      -1
-## D (A)   N (A)
-## @end group
-## @end example
+## @verbatim
+##           -1
+##      D (A)   N (A)
+## @end verbatim
 ##
 ## @end ifnottex
 ## whose Taylor series matches the first
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/null.m
--- a/scripts/linear-algebra/null.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/null.m	Tue May 12 23:20:22 2015 +0100
@@ -25,9 +25,9 @@
 ## values of @var{A} not greater than @var{tol}.  If the argument @var{tol}
 ## is missing, it is computed as
 ##
-## @example
-## max (size (@var{A})) * max (svd (@var{A})) * eps
-## @end example
+## @verbatim
+##      max (size (@var{A})) * max (svd (@var{A})) * eps
+## @end verbatim
 ## @seealso{orth}
 ## @end deftypefn
 
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/orth.m
--- a/scripts/linear-algebra/orth.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/orth.m	Tue May 12 23:20:22 2015 +0100
@@ -25,9 +25,9 @@
 ## values of @var{A} greater than @var{tol}.  If the argument @var{tol} is
 ## missing, it is computed as
 ##
-## @example
-## max (size (@var{A})) * max (svd (@var{A})) * eps
-## @end example
+## @verbatim
+##      max (size (@var{A})) * max (svd (@var{A})) * eps
+## @end verbatim
 ## @seealso{null}
 ## @end deftypefn
 
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/qzhess.m
--- a/scripts/linear-algebra/qzhess.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/qzhess.m	Tue May 12 23:20:22 2015 +0100
@@ -27,10 +27,19 @@
 ## @example
 ## @group
 ## [aa, bb, q, z] = qzhess ([1, 2; 3, 4], [5, 6; 7, 8])
-##      @result{} aa = [ -3.02244, -4.41741;  0.92998,  0.69749 ]
-##      @result{} bb = [ -8.60233, -9.99730;  0.00000, -0.23250 ]
-##      @result{}  q = [ -0.58124, -0.81373; -0.81373,  0.58124 ]
-##      @result{}  z = [ 1, 0; 0, 1 ]
+##   @result{} aa =
+##        -3.02244  -4.41741
+##         0.92998   0.69749
+##      bb =
+##        -8.60233  -9.99730
+##         0.00000  -0.23250
+##      q =
+##        -0.58124  -0.81373
+##        -0.81373   0.58124
+##      z =
+##      Diagonal Matrix
+##         1  0
+##         0  1
 ## @end group
 ## @end example
 ##
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/linear-algebra/rank.m
--- a/scripts/linear-algebra/rank.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/linear-algebra/rank.m	Tue May 12 23:20:22 2015 +0100
@@ -25,9 +25,9 @@
 ## are greater than the specified tolerance @var{tol}.  If the second
 ## argument is omitted, it is taken to be
 ##
-## @example
-## tol = max (size (@var{A})) * sigma(1) * eps;
-## @end example
+## @verbatim
+##      tol = max (size (@var{A})) * sigma(1) * eps;
+## @end verbatim
 ##
 ## @noindent
 ## where @code{eps} is machine precision and @code{sigma(1)} is the largest
diff -r a29374f709a5 -r 52f3f59f0fbe scripts/sparse/spdiags.m
--- a/scripts/sparse/spdiags.m	Thu Apr 30 15:47:06 2015 +0100
+++ b/scripts/sparse/spdiags.m	Tue May 12 23:20:22 2015 +0100
@@ -42,12 +42,13 @@
 ##
 ## @example
 ## @group
-## spdiags (reshape (1:12, 4, 3), [-1 0 1], 5, 4)
-##    @result{} 5 10  0  0
-##       1  6 11  0
-##       0  2  7 12
-##       0  0  3  8
-##       0  0  0  4
+## A = spdiags (reshape (1:12, 4, 3), [-1 0 1], 5, 4);
+## full (A)
+##    @result{} 5   10    0    0
+##       1    6   11    0
+##       0    2    7   12
+##       0    0    3    8
+##       0    0    0    4
 ## @end group
 ## @end example
 ##